//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private anaSqueeze[] cacheanaSqueeze = null;
        private NTChops[] cacheNTChops = null;
        private NTDeltaCross6E[] cacheNTDeltaCross6E = null;
        private NTDeltaCrossADD[] cacheNTDeltaCrossADD = null;
        private NTDeltaCrossCL[] cacheNTDeltaCrossCL = null;
        private NTDeltaCrossES[] cacheNTDeltaCrossES = null;
        private NTDeltaCrossGC[] cacheNTDeltaCrossGC = null;
        private NTDeltaCrossHG[] cacheNTDeltaCrossHG = null;
        private NTDeltaCrossNG[] cacheNTDeltaCrossNG = null;
        private NTDeltaCrossNQ[] cacheNTDeltaCrossNQ = null;
        private NTDeltaCrossTF[] cacheNTDeltaCrossTF = null;
        private NTDeltaCrossYM[] cacheNTDeltaCrossYM = null;
        private NTDeltaCrossZ[] cacheNTDeltaCrossZ = null;
        private NTDeltaCrossZC[] cacheNTDeltaCrossZC = null;
        private NTDeltaCrossZS[] cacheNTDeltaCrossZS = null;
        private NTFractals[] cacheNTFractals = null;
        private NTMACloud[] cacheNTMACloud = null;
        private NTTimeBlock[] cacheNTTimeBlock = null;
        private NTUltimateCandle6E[] cacheNTUltimateCandle6E = null;
        private NTUltimateCandleCL[] cacheNTUltimateCandleCL = null;
        private NTUltimateCandleES[] cacheNTUltimateCandleES = null;
        private NTUltimateCandleGC[] cacheNTUltimateCandleGC = null;
        private NTUltimateCandleHelper[] cacheNTUltimateCandleHelper = null;
        private NTUltimateCandleHelperES[] cacheNTUltimateCandleHelperES = null;
        private NTUltimateCandleHG[] cacheNTUltimateCandleHG = null;
        private NTUltimateCandleNG[] cacheNTUltimateCandleNG = null;
        private NTUltimateCandleNQ[] cacheNTUltimateCandleNQ = null;
        private NTUltimateCandleTF[] cacheNTUltimateCandleTF = null;
        private NTUltimateCandleYM[] cacheNTUltimateCandleYM = null;
        private NTUltimateCandleZ[] cacheNTUltimateCandleZ = null;
        private NTUltimateCandleZC[] cacheNTUltimateCandleZC = null;
        private NTUltimateCandleZS[] cacheNTUltimateCandleZS = null;

        private static anaSqueeze checkanaSqueeze = new anaSqueeze();
        private static NTChops checkNTChops = new NTChops();
        private static NTDeltaCross6E checkNTDeltaCross6E = new NTDeltaCross6E();
        private static NTDeltaCrossADD checkNTDeltaCrossADD = new NTDeltaCrossADD();
        private static NTDeltaCrossCL checkNTDeltaCrossCL = new NTDeltaCrossCL();
        private static NTDeltaCrossES checkNTDeltaCrossES = new NTDeltaCrossES();
        private static NTDeltaCrossGC checkNTDeltaCrossGC = new NTDeltaCrossGC();
        private static NTDeltaCrossHG checkNTDeltaCrossHG = new NTDeltaCrossHG();
        private static NTDeltaCrossNG checkNTDeltaCrossNG = new NTDeltaCrossNG();
        private static NTDeltaCrossNQ checkNTDeltaCrossNQ = new NTDeltaCrossNQ();
        private static NTDeltaCrossTF checkNTDeltaCrossTF = new NTDeltaCrossTF();
        private static NTDeltaCrossYM checkNTDeltaCrossYM = new NTDeltaCrossYM();
        private static NTDeltaCrossZ checkNTDeltaCrossZ = new NTDeltaCrossZ();
        private static NTDeltaCrossZC checkNTDeltaCrossZC = new NTDeltaCrossZC();
        private static NTDeltaCrossZS checkNTDeltaCrossZS = new NTDeltaCrossZS();
        private static NTFractals checkNTFractals = new NTFractals();
        private static NTMACloud checkNTMACloud = new NTMACloud();
        private static NTTimeBlock checkNTTimeBlock = new NTTimeBlock();
        private static NTUltimateCandle6E checkNTUltimateCandle6E = new NTUltimateCandle6E();
        private static NTUltimateCandleCL checkNTUltimateCandleCL = new NTUltimateCandleCL();
        private static NTUltimateCandleES checkNTUltimateCandleES = new NTUltimateCandleES();
        private static NTUltimateCandleGC checkNTUltimateCandleGC = new NTUltimateCandleGC();
        private static NTUltimateCandleHelper checkNTUltimateCandleHelper = new NTUltimateCandleHelper();
        private static NTUltimateCandleHelperES checkNTUltimateCandleHelperES = new NTUltimateCandleHelperES();
        private static NTUltimateCandleHG checkNTUltimateCandleHG = new NTUltimateCandleHG();
        private static NTUltimateCandleNG checkNTUltimateCandleNG = new NTUltimateCandleNG();
        private static NTUltimateCandleNQ checkNTUltimateCandleNQ = new NTUltimateCandleNQ();
        private static NTUltimateCandleTF checkNTUltimateCandleTF = new NTUltimateCandleTF();
        private static NTUltimateCandleYM checkNTUltimateCandleYM = new NTUltimateCandleYM();
        private static NTUltimateCandleZ checkNTUltimateCandleZ = new NTUltimateCandleZ();
        private static NTUltimateCandleZC checkNTUltimateCandleZC = new NTUltimateCandleZC();
        private static NTUltimateCandleZS checkNTUltimateCandleZS = new NTUltimateCandleZS();

        /// <summary>
        ///  The squeeze indicator shows when the Bollinger Bands are contracting stronger than a Keltner Channel.
        /// </summary>
        /// <returns></returns>
        public anaSqueeze anaSqueeze(double numMultiplier, double numStdDev, int period)
        {
            return anaSqueeze(Input, numMultiplier, numStdDev, period);
        }

        /// <summary>
        ///  The squeeze indicator shows when the Bollinger Bands are contracting stronger than a Keltner Channel.
        /// </summary>
        /// <returns></returns>
        public anaSqueeze anaSqueeze(Data.IDataSeries input, double numMultiplier, double numStdDev, int period)
        {
            if (cacheanaSqueeze != null)
                for (int idx = 0; idx < cacheanaSqueeze.Length; idx++)
                    if (Math.Abs(cacheanaSqueeze[idx].NumMultiplier - numMultiplier) <= double.Epsilon && Math.Abs(cacheanaSqueeze[idx].NumStdDev - numStdDev) <= double.Epsilon && cacheanaSqueeze[idx].Period == period && cacheanaSqueeze[idx].EqualsInput(input))
                        return cacheanaSqueeze[idx];

            lock (checkanaSqueeze)
            {
                checkanaSqueeze.NumMultiplier = numMultiplier;
                numMultiplier = checkanaSqueeze.NumMultiplier;
                checkanaSqueeze.NumStdDev = numStdDev;
                numStdDev = checkanaSqueeze.NumStdDev;
                checkanaSqueeze.Period = period;
                period = checkanaSqueeze.Period;

                if (cacheanaSqueeze != null)
                    for (int idx = 0; idx < cacheanaSqueeze.Length; idx++)
                        if (Math.Abs(cacheanaSqueeze[idx].NumMultiplier - numMultiplier) <= double.Epsilon && Math.Abs(cacheanaSqueeze[idx].NumStdDev - numStdDev) <= double.Epsilon && cacheanaSqueeze[idx].Period == period && cacheanaSqueeze[idx].EqualsInput(input))
                            return cacheanaSqueeze[idx];

                anaSqueeze indicator = new anaSqueeze();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.NumMultiplier = numMultiplier;
                indicator.NumStdDev = numStdDev;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                anaSqueeze[] tmp = new anaSqueeze[cacheanaSqueeze == null ? 1 : cacheanaSqueeze.Length + 1];
                if (cacheanaSqueeze != null)
                    cacheanaSqueeze.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheanaSqueeze = tmp;
                return indicator;
            }
        }

        /// <summary>
        ///  The squeeze indicator shows when the Bollinger Bands are contracting stronger than a Keltner Channel.
        /// </summary>
        /// <returns></returns>
        public NTChops NTChops(double numMultiplier, double numStdDev, int period)
        {
            return NTChops(Input, numMultiplier, numStdDev, period);
        }

        /// <summary>
        ///  The squeeze indicator shows when the Bollinger Bands are contracting stronger than a Keltner Channel.
        /// </summary>
        /// <returns></returns>
        public NTChops NTChops(Data.IDataSeries input, double numMultiplier, double numStdDev, int period)
        {
            if (cacheNTChops != null)
                for (int idx = 0; idx < cacheNTChops.Length; idx++)
                    if (Math.Abs(cacheNTChops[idx].NumMultiplier - numMultiplier) <= double.Epsilon && Math.Abs(cacheNTChops[idx].NumStdDev - numStdDev) <= double.Epsilon && cacheNTChops[idx].Period == period && cacheNTChops[idx].EqualsInput(input))
                        return cacheNTChops[idx];

            lock (checkNTChops)
            {
                checkNTChops.NumMultiplier = numMultiplier;
                numMultiplier = checkNTChops.NumMultiplier;
                checkNTChops.NumStdDev = numStdDev;
                numStdDev = checkNTChops.NumStdDev;
                checkNTChops.Period = period;
                period = checkNTChops.Period;

                if (cacheNTChops != null)
                    for (int idx = 0; idx < cacheNTChops.Length; idx++)
                        if (Math.Abs(cacheNTChops[idx].NumMultiplier - numMultiplier) <= double.Epsilon && Math.Abs(cacheNTChops[idx].NumStdDev - numStdDev) <= double.Epsilon && cacheNTChops[idx].Period == period && cacheNTChops[idx].EqualsInput(input))
                            return cacheNTChops[idx];

                NTChops indicator = new NTChops();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.NumMultiplier = numMultiplier;
                indicator.NumStdDev = numStdDev;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTChops[] tmp = new NTChops[cacheNTChops == null ? 1 : cacheNTChops.Length + 1];
                if (cacheNTChops != null)
                    cacheNTChops.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTChops = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCross6E NTDeltaCross6E()
        {
            return NTDeltaCross6E(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCross6E NTDeltaCross6E(Data.IDataSeries input)
        {
            if (cacheNTDeltaCross6E != null)
                for (int idx = 0; idx < cacheNTDeltaCross6E.Length; idx++)
                    if (cacheNTDeltaCross6E[idx].EqualsInput(input))
                        return cacheNTDeltaCross6E[idx];

            lock (checkNTDeltaCross6E)
            {
                if (cacheNTDeltaCross6E != null)
                    for (int idx = 0; idx < cacheNTDeltaCross6E.Length; idx++)
                        if (cacheNTDeltaCross6E[idx].EqualsInput(input))
                            return cacheNTDeltaCross6E[idx];

                NTDeltaCross6E indicator = new NTDeltaCross6E();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCross6E[] tmp = new NTDeltaCross6E[cacheNTDeltaCross6E == null ? 1 : cacheNTDeltaCross6E.Length + 1];
                if (cacheNTDeltaCross6E != null)
                    cacheNTDeltaCross6E.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCross6E = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossADD NTDeltaCrossADD()
        {
            return NTDeltaCrossADD(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossADD NTDeltaCrossADD(Data.IDataSeries input)
        {
            if (cacheNTDeltaCrossADD != null)
                for (int idx = 0; idx < cacheNTDeltaCrossADD.Length; idx++)
                    if (cacheNTDeltaCrossADD[idx].EqualsInput(input))
                        return cacheNTDeltaCrossADD[idx];

            lock (checkNTDeltaCrossADD)
            {
                if (cacheNTDeltaCrossADD != null)
                    for (int idx = 0; idx < cacheNTDeltaCrossADD.Length; idx++)
                        if (cacheNTDeltaCrossADD[idx].EqualsInput(input))
                            return cacheNTDeltaCrossADD[idx];

                NTDeltaCrossADD indicator = new NTDeltaCrossADD();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCrossADD[] tmp = new NTDeltaCrossADD[cacheNTDeltaCrossADD == null ? 1 : cacheNTDeltaCrossADD.Length + 1];
                if (cacheNTDeltaCrossADD != null)
                    cacheNTDeltaCrossADD.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCrossADD = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossCL NTDeltaCrossCL()
        {
            return NTDeltaCrossCL(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossCL NTDeltaCrossCL(Data.IDataSeries input)
        {
            if (cacheNTDeltaCrossCL != null)
                for (int idx = 0; idx < cacheNTDeltaCrossCL.Length; idx++)
                    if (cacheNTDeltaCrossCL[idx].EqualsInput(input))
                        return cacheNTDeltaCrossCL[idx];

            lock (checkNTDeltaCrossCL)
            {
                if (cacheNTDeltaCrossCL != null)
                    for (int idx = 0; idx < cacheNTDeltaCrossCL.Length; idx++)
                        if (cacheNTDeltaCrossCL[idx].EqualsInput(input))
                            return cacheNTDeltaCrossCL[idx];

                NTDeltaCrossCL indicator = new NTDeltaCrossCL();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCrossCL[] tmp = new NTDeltaCrossCL[cacheNTDeltaCrossCL == null ? 1 : cacheNTDeltaCrossCL.Length + 1];
                if (cacheNTDeltaCrossCL != null)
                    cacheNTDeltaCrossCL.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCrossCL = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossES NTDeltaCrossES()
        {
            return NTDeltaCrossES(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossES NTDeltaCrossES(Data.IDataSeries input)
        {
            if (cacheNTDeltaCrossES != null)
                for (int idx = 0; idx < cacheNTDeltaCrossES.Length; idx++)
                    if (cacheNTDeltaCrossES[idx].EqualsInput(input))
                        return cacheNTDeltaCrossES[idx];

            lock (checkNTDeltaCrossES)
            {
                if (cacheNTDeltaCrossES != null)
                    for (int idx = 0; idx < cacheNTDeltaCrossES.Length; idx++)
                        if (cacheNTDeltaCrossES[idx].EqualsInput(input))
                            return cacheNTDeltaCrossES[idx];

                NTDeltaCrossES indicator = new NTDeltaCrossES();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCrossES[] tmp = new NTDeltaCrossES[cacheNTDeltaCrossES == null ? 1 : cacheNTDeltaCrossES.Length + 1];
                if (cacheNTDeltaCrossES != null)
                    cacheNTDeltaCrossES.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCrossES = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossGC NTDeltaCrossGC()
        {
            return NTDeltaCrossGC(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossGC NTDeltaCrossGC(Data.IDataSeries input)
        {
            if (cacheNTDeltaCrossGC != null)
                for (int idx = 0; idx < cacheNTDeltaCrossGC.Length; idx++)
                    if (cacheNTDeltaCrossGC[idx].EqualsInput(input))
                        return cacheNTDeltaCrossGC[idx];

            lock (checkNTDeltaCrossGC)
            {
                if (cacheNTDeltaCrossGC != null)
                    for (int idx = 0; idx < cacheNTDeltaCrossGC.Length; idx++)
                        if (cacheNTDeltaCrossGC[idx].EqualsInput(input))
                            return cacheNTDeltaCrossGC[idx];

                NTDeltaCrossGC indicator = new NTDeltaCrossGC();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCrossGC[] tmp = new NTDeltaCrossGC[cacheNTDeltaCrossGC == null ? 1 : cacheNTDeltaCrossGC.Length + 1];
                if (cacheNTDeltaCrossGC != null)
                    cacheNTDeltaCrossGC.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCrossGC = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossHG NTDeltaCrossHG()
        {
            return NTDeltaCrossHG(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossHG NTDeltaCrossHG(Data.IDataSeries input)
        {
            if (cacheNTDeltaCrossHG != null)
                for (int idx = 0; idx < cacheNTDeltaCrossHG.Length; idx++)
                    if (cacheNTDeltaCrossHG[idx].EqualsInput(input))
                        return cacheNTDeltaCrossHG[idx];

            lock (checkNTDeltaCrossHG)
            {
                if (cacheNTDeltaCrossHG != null)
                    for (int idx = 0; idx < cacheNTDeltaCrossHG.Length; idx++)
                        if (cacheNTDeltaCrossHG[idx].EqualsInput(input))
                            return cacheNTDeltaCrossHG[idx];

                NTDeltaCrossHG indicator = new NTDeltaCrossHG();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCrossHG[] tmp = new NTDeltaCrossHG[cacheNTDeltaCrossHG == null ? 1 : cacheNTDeltaCrossHG.Length + 1];
                if (cacheNTDeltaCrossHG != null)
                    cacheNTDeltaCrossHG.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCrossHG = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossNG NTDeltaCrossNG()
        {
            return NTDeltaCrossNG(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossNG NTDeltaCrossNG(Data.IDataSeries input)
        {
            if (cacheNTDeltaCrossNG != null)
                for (int idx = 0; idx < cacheNTDeltaCrossNG.Length; idx++)
                    if (cacheNTDeltaCrossNG[idx].EqualsInput(input))
                        return cacheNTDeltaCrossNG[idx];

            lock (checkNTDeltaCrossNG)
            {
                if (cacheNTDeltaCrossNG != null)
                    for (int idx = 0; idx < cacheNTDeltaCrossNG.Length; idx++)
                        if (cacheNTDeltaCrossNG[idx].EqualsInput(input))
                            return cacheNTDeltaCrossNG[idx];

                NTDeltaCrossNG indicator = new NTDeltaCrossNG();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCrossNG[] tmp = new NTDeltaCrossNG[cacheNTDeltaCrossNG == null ? 1 : cacheNTDeltaCrossNG.Length + 1];
                if (cacheNTDeltaCrossNG != null)
                    cacheNTDeltaCrossNG.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCrossNG = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossNQ NTDeltaCrossNQ()
        {
            return NTDeltaCrossNQ(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossNQ NTDeltaCrossNQ(Data.IDataSeries input)
        {
            if (cacheNTDeltaCrossNQ != null)
                for (int idx = 0; idx < cacheNTDeltaCrossNQ.Length; idx++)
                    if (cacheNTDeltaCrossNQ[idx].EqualsInput(input))
                        return cacheNTDeltaCrossNQ[idx];

            lock (checkNTDeltaCrossNQ)
            {
                if (cacheNTDeltaCrossNQ != null)
                    for (int idx = 0; idx < cacheNTDeltaCrossNQ.Length; idx++)
                        if (cacheNTDeltaCrossNQ[idx].EqualsInput(input))
                            return cacheNTDeltaCrossNQ[idx];

                NTDeltaCrossNQ indicator = new NTDeltaCrossNQ();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCrossNQ[] tmp = new NTDeltaCrossNQ[cacheNTDeltaCrossNQ == null ? 1 : cacheNTDeltaCrossNQ.Length + 1];
                if (cacheNTDeltaCrossNQ != null)
                    cacheNTDeltaCrossNQ.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCrossNQ = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossTF NTDeltaCrossTF()
        {
            return NTDeltaCrossTF(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossTF NTDeltaCrossTF(Data.IDataSeries input)
        {
            if (cacheNTDeltaCrossTF != null)
                for (int idx = 0; idx < cacheNTDeltaCrossTF.Length; idx++)
                    if (cacheNTDeltaCrossTF[idx].EqualsInput(input))
                        return cacheNTDeltaCrossTF[idx];

            lock (checkNTDeltaCrossTF)
            {
                if (cacheNTDeltaCrossTF != null)
                    for (int idx = 0; idx < cacheNTDeltaCrossTF.Length; idx++)
                        if (cacheNTDeltaCrossTF[idx].EqualsInput(input))
                            return cacheNTDeltaCrossTF[idx];

                NTDeltaCrossTF indicator = new NTDeltaCrossTF();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCrossTF[] tmp = new NTDeltaCrossTF[cacheNTDeltaCrossTF == null ? 1 : cacheNTDeltaCrossTF.Length + 1];
                if (cacheNTDeltaCrossTF != null)
                    cacheNTDeltaCrossTF.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCrossTF = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossYM NTDeltaCrossYM()
        {
            return NTDeltaCrossYM(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossYM NTDeltaCrossYM(Data.IDataSeries input)
        {
            if (cacheNTDeltaCrossYM != null)
                for (int idx = 0; idx < cacheNTDeltaCrossYM.Length; idx++)
                    if (cacheNTDeltaCrossYM[idx].EqualsInput(input))
                        return cacheNTDeltaCrossYM[idx];

            lock (checkNTDeltaCrossYM)
            {
                if (cacheNTDeltaCrossYM != null)
                    for (int idx = 0; idx < cacheNTDeltaCrossYM.Length; idx++)
                        if (cacheNTDeltaCrossYM[idx].EqualsInput(input))
                            return cacheNTDeltaCrossYM[idx];

                NTDeltaCrossYM indicator = new NTDeltaCrossYM();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCrossYM[] tmp = new NTDeltaCrossYM[cacheNTDeltaCrossYM == null ? 1 : cacheNTDeltaCrossYM.Length + 1];
                if (cacheNTDeltaCrossYM != null)
                    cacheNTDeltaCrossYM.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCrossYM = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossZ NTDeltaCrossZ()
        {
            return NTDeltaCrossZ(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossZ NTDeltaCrossZ(Data.IDataSeries input)
        {
            if (cacheNTDeltaCrossZ != null)
                for (int idx = 0; idx < cacheNTDeltaCrossZ.Length; idx++)
                    if (cacheNTDeltaCrossZ[idx].EqualsInput(input))
                        return cacheNTDeltaCrossZ[idx];

            lock (checkNTDeltaCrossZ)
            {
                if (cacheNTDeltaCrossZ != null)
                    for (int idx = 0; idx < cacheNTDeltaCrossZ.Length; idx++)
                        if (cacheNTDeltaCrossZ[idx].EqualsInput(input))
                            return cacheNTDeltaCrossZ[idx];

                NTDeltaCrossZ indicator = new NTDeltaCrossZ();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCrossZ[] tmp = new NTDeltaCrossZ[cacheNTDeltaCrossZ == null ? 1 : cacheNTDeltaCrossZ.Length + 1];
                if (cacheNTDeltaCrossZ != null)
                    cacheNTDeltaCrossZ.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCrossZ = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossZC NTDeltaCrossZC()
        {
            return NTDeltaCrossZC(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossZC NTDeltaCrossZC(Data.IDataSeries input)
        {
            if (cacheNTDeltaCrossZC != null)
                for (int idx = 0; idx < cacheNTDeltaCrossZC.Length; idx++)
                    if (cacheNTDeltaCrossZC[idx].EqualsInput(input))
                        return cacheNTDeltaCrossZC[idx];

            lock (checkNTDeltaCrossZC)
            {
                if (cacheNTDeltaCrossZC != null)
                    for (int idx = 0; idx < cacheNTDeltaCrossZC.Length; idx++)
                        if (cacheNTDeltaCrossZC[idx].EqualsInput(input))
                            return cacheNTDeltaCrossZC[idx];

                NTDeltaCrossZC indicator = new NTDeltaCrossZC();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCrossZC[] tmp = new NTDeltaCrossZC[cacheNTDeltaCrossZC == null ? 1 : cacheNTDeltaCrossZC.Length + 1];
                if (cacheNTDeltaCrossZC != null)
                    cacheNTDeltaCrossZC.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCrossZC = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossZS NTDeltaCrossZS()
        {
            return NTDeltaCrossZS(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTDeltaCrossZS NTDeltaCrossZS(Data.IDataSeries input)
        {
            if (cacheNTDeltaCrossZS != null)
                for (int idx = 0; idx < cacheNTDeltaCrossZS.Length; idx++)
                    if (cacheNTDeltaCrossZS[idx].EqualsInput(input))
                        return cacheNTDeltaCrossZS[idx];

            lock (checkNTDeltaCrossZS)
            {
                if (cacheNTDeltaCrossZS != null)
                    for (int idx = 0; idx < cacheNTDeltaCrossZS.Length; idx++)
                        if (cacheNTDeltaCrossZS[idx].EqualsInput(input))
                            return cacheNTDeltaCrossZS[idx];

                NTDeltaCrossZS indicator = new NTDeltaCrossZS();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTDeltaCrossZS[] tmp = new NTDeltaCrossZS[cacheNTDeltaCrossZS == null ? 1 : cacheNTDeltaCrossZS.Length + 1];
                if (cacheNTDeltaCrossZS != null)
                    cacheNTDeltaCrossZS.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTDeltaCrossZS = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTFractals NTFractals(int alternativeEntryEMAPeriod, bool autoStopNLNH, int autoStopNLNHTicks, NTFractalsFirstEntrySignal firstEntrySignal, bool implementNCTZ, int initialStopTicks, NTFractalsLetterDisplayOptions letterDisplayOptions, NTFractalsLineDisplayOptions lineDisplayOptions, NTMACloudMAType mAType1, NTMACloudMAType mAType2, bool nTDeltaCrossEntryFilter, bool nTDeltaCrossTrailingStopFilter, NTFractalsDeltaCrossOptions nTFractalsDeltaCrossEntryOption, NTFractalsDeltaCrossOptions nTFractalsDeltaCrossTrailingStopOption, NTFractalsUltimateCandleOptions nTFractalsUltimateCandleEntryOption, NTFractalsUltimateCandleOptions nTFractalsUltimateCandleTrailingStopOption, bool nTMACloudEntryFilter, bool nTUltimateCandleEntryFilter, int nTUltimateCandleFilterNTMACloudReqEMAPeriod, bool nTUltimateCandleNTDeltaCrossTrailingStopCombo, bool nTUltimateCandleTrailingStopFilter, bool nTUltimateCandleTrailingStopMACloudReq, NTFractalsNumberOfEntrySignals numberOfEntrySignals, bool overrideEntryPlotColor, int period1, int period2, bool showReversalEntries, Font textFont, bool trailingStopEntry, bool trailingStopNLNH, bool trailingStopPBS, int trailingStopTicks)
        {
            return NTFractals(Input, alternativeEntryEMAPeriod, autoStopNLNH, autoStopNLNHTicks, firstEntrySignal, implementNCTZ, initialStopTicks, letterDisplayOptions, lineDisplayOptions, mAType1, mAType2, nTDeltaCrossEntryFilter, nTDeltaCrossTrailingStopFilter, nTFractalsDeltaCrossEntryOption, nTFractalsDeltaCrossTrailingStopOption, nTFractalsUltimateCandleEntryOption, nTFractalsUltimateCandleTrailingStopOption, nTMACloudEntryFilter, nTUltimateCandleEntryFilter, nTUltimateCandleFilterNTMACloudReqEMAPeriod, nTUltimateCandleNTDeltaCrossTrailingStopCombo, nTUltimateCandleTrailingStopFilter, nTUltimateCandleTrailingStopMACloudReq, numberOfEntrySignals, overrideEntryPlotColor, period1, period2, showReversalEntries, textFont, trailingStopEntry, trailingStopNLNH, trailingStopPBS, trailingStopTicks);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTFractals NTFractals(Data.IDataSeries input, int alternativeEntryEMAPeriod, bool autoStopNLNH, int autoStopNLNHTicks, NTFractalsFirstEntrySignal firstEntrySignal, bool implementNCTZ, int initialStopTicks, NTFractalsLetterDisplayOptions letterDisplayOptions, NTFractalsLineDisplayOptions lineDisplayOptions, NTMACloudMAType mAType1, NTMACloudMAType mAType2, bool nTDeltaCrossEntryFilter, bool nTDeltaCrossTrailingStopFilter, NTFractalsDeltaCrossOptions nTFractalsDeltaCrossEntryOption, NTFractalsDeltaCrossOptions nTFractalsDeltaCrossTrailingStopOption, NTFractalsUltimateCandleOptions nTFractalsUltimateCandleEntryOption, NTFractalsUltimateCandleOptions nTFractalsUltimateCandleTrailingStopOption, bool nTMACloudEntryFilter, bool nTUltimateCandleEntryFilter, int nTUltimateCandleFilterNTMACloudReqEMAPeriod, bool nTUltimateCandleNTDeltaCrossTrailingStopCombo, bool nTUltimateCandleTrailingStopFilter, bool nTUltimateCandleTrailingStopMACloudReq, NTFractalsNumberOfEntrySignals numberOfEntrySignals, bool overrideEntryPlotColor, int period1, int period2, bool showReversalEntries, Font textFont, bool trailingStopEntry, bool trailingStopNLNH, bool trailingStopPBS, int trailingStopTicks)
        {
            if (cacheNTFractals != null)
                for (int idx = 0; idx < cacheNTFractals.Length; idx++)
                    if (cacheNTFractals[idx].AlternativeEntryEMAPeriod == alternativeEntryEMAPeriod && cacheNTFractals[idx].AutoStopNLNH == autoStopNLNH && cacheNTFractals[idx].AutoStopNLNHTicks == autoStopNLNHTicks && cacheNTFractals[idx].FirstEntrySignal == firstEntrySignal && cacheNTFractals[idx].ImplementNCTZ == implementNCTZ && cacheNTFractals[idx].InitialStopTicks == initialStopTicks && cacheNTFractals[idx].LetterDisplayOptions == letterDisplayOptions && cacheNTFractals[idx].LineDisplayOptions == lineDisplayOptions && cacheNTFractals[idx].MAType1 == mAType1 && cacheNTFractals[idx].MAType2 == mAType2 && cacheNTFractals[idx].NTDeltaCrossEntryFilter == nTDeltaCrossEntryFilter && cacheNTFractals[idx].NTDeltaCrossTrailingStopFilter == nTDeltaCrossTrailingStopFilter && cacheNTFractals[idx].NTFractalsDeltaCrossEntryOption == nTFractalsDeltaCrossEntryOption && cacheNTFractals[idx].NTFractalsDeltaCrossTrailingStopOption == nTFractalsDeltaCrossTrailingStopOption && cacheNTFractals[idx].NTFractalsUltimateCandleEntryOption == nTFractalsUltimateCandleEntryOption && cacheNTFractals[idx].NTFractalsUltimateCandleTrailingStopOption == nTFractalsUltimateCandleTrailingStopOption && cacheNTFractals[idx].NTMACloudEntryFilter == nTMACloudEntryFilter && cacheNTFractals[idx].NTUltimateCandleEntryFilter == nTUltimateCandleEntryFilter && cacheNTFractals[idx].NTUltimateCandleFilterNTMACloudReqEMAPeriod == nTUltimateCandleFilterNTMACloudReqEMAPeriod && cacheNTFractals[idx].NTUltimateCandleNTDeltaCrossTrailingStopCombo == nTUltimateCandleNTDeltaCrossTrailingStopCombo && cacheNTFractals[idx].NTUltimateCandleTrailingStopFilter == nTUltimateCandleTrailingStopFilter && cacheNTFractals[idx].NTUltimateCandleTrailingStopMACloudReq == nTUltimateCandleTrailingStopMACloudReq && cacheNTFractals[idx].NumberOfEntrySignals == numberOfEntrySignals && cacheNTFractals[idx].OverrideEntryPlotColor == overrideEntryPlotColor && cacheNTFractals[idx].Period1 == period1 && cacheNTFractals[idx].Period2 == period2 && cacheNTFractals[idx].ShowReversalEntries == showReversalEntries && cacheNTFractals[idx].TextFont == textFont && cacheNTFractals[idx].TrailingStopEntry == trailingStopEntry && cacheNTFractals[idx].TrailingStopNLNH == trailingStopNLNH && cacheNTFractals[idx].TrailingStopPBS == trailingStopPBS && cacheNTFractals[idx].TrailingStopTicks == trailingStopTicks && cacheNTFractals[idx].EqualsInput(input))
                        return cacheNTFractals[idx];

            lock (checkNTFractals)
            {
                checkNTFractals.AlternativeEntryEMAPeriod = alternativeEntryEMAPeriod;
                alternativeEntryEMAPeriod = checkNTFractals.AlternativeEntryEMAPeriod;
                checkNTFractals.AutoStopNLNH = autoStopNLNH;
                autoStopNLNH = checkNTFractals.AutoStopNLNH;
                checkNTFractals.AutoStopNLNHTicks = autoStopNLNHTicks;
                autoStopNLNHTicks = checkNTFractals.AutoStopNLNHTicks;
                checkNTFractals.FirstEntrySignal = firstEntrySignal;
                firstEntrySignal = checkNTFractals.FirstEntrySignal;
                checkNTFractals.ImplementNCTZ = implementNCTZ;
                implementNCTZ = checkNTFractals.ImplementNCTZ;
                checkNTFractals.InitialStopTicks = initialStopTicks;
                initialStopTicks = checkNTFractals.InitialStopTicks;
                checkNTFractals.LetterDisplayOptions = letterDisplayOptions;
                letterDisplayOptions = checkNTFractals.LetterDisplayOptions;
                checkNTFractals.LineDisplayOptions = lineDisplayOptions;
                lineDisplayOptions = checkNTFractals.LineDisplayOptions;
                checkNTFractals.MAType1 = mAType1;
                mAType1 = checkNTFractals.MAType1;
                checkNTFractals.MAType2 = mAType2;
                mAType2 = checkNTFractals.MAType2;
                checkNTFractals.NTDeltaCrossEntryFilter = nTDeltaCrossEntryFilter;
                nTDeltaCrossEntryFilter = checkNTFractals.NTDeltaCrossEntryFilter;
                checkNTFractals.NTDeltaCrossTrailingStopFilter = nTDeltaCrossTrailingStopFilter;
                nTDeltaCrossTrailingStopFilter = checkNTFractals.NTDeltaCrossTrailingStopFilter;
                checkNTFractals.NTFractalsDeltaCrossEntryOption = nTFractalsDeltaCrossEntryOption;
                nTFractalsDeltaCrossEntryOption = checkNTFractals.NTFractalsDeltaCrossEntryOption;
                checkNTFractals.NTFractalsDeltaCrossTrailingStopOption = nTFractalsDeltaCrossTrailingStopOption;
                nTFractalsDeltaCrossTrailingStopOption = checkNTFractals.NTFractalsDeltaCrossTrailingStopOption;
                checkNTFractals.NTFractalsUltimateCandleEntryOption = nTFractalsUltimateCandleEntryOption;
                nTFractalsUltimateCandleEntryOption = checkNTFractals.NTFractalsUltimateCandleEntryOption;
                checkNTFractals.NTFractalsUltimateCandleTrailingStopOption = nTFractalsUltimateCandleTrailingStopOption;
                nTFractalsUltimateCandleTrailingStopOption = checkNTFractals.NTFractalsUltimateCandleTrailingStopOption;
                checkNTFractals.NTMACloudEntryFilter = nTMACloudEntryFilter;
                nTMACloudEntryFilter = checkNTFractals.NTMACloudEntryFilter;
                checkNTFractals.NTUltimateCandleEntryFilter = nTUltimateCandleEntryFilter;
                nTUltimateCandleEntryFilter = checkNTFractals.NTUltimateCandleEntryFilter;
                checkNTFractals.NTUltimateCandleFilterNTMACloudReqEMAPeriod = nTUltimateCandleFilterNTMACloudReqEMAPeriod;
                nTUltimateCandleFilterNTMACloudReqEMAPeriod = checkNTFractals.NTUltimateCandleFilterNTMACloudReqEMAPeriod;
                checkNTFractals.NTUltimateCandleNTDeltaCrossTrailingStopCombo = nTUltimateCandleNTDeltaCrossTrailingStopCombo;
                nTUltimateCandleNTDeltaCrossTrailingStopCombo = checkNTFractals.NTUltimateCandleNTDeltaCrossTrailingStopCombo;
                checkNTFractals.NTUltimateCandleTrailingStopFilter = nTUltimateCandleTrailingStopFilter;
                nTUltimateCandleTrailingStopFilter = checkNTFractals.NTUltimateCandleTrailingStopFilter;
                checkNTFractals.NTUltimateCandleTrailingStopMACloudReq = nTUltimateCandleTrailingStopMACloudReq;
                nTUltimateCandleTrailingStopMACloudReq = checkNTFractals.NTUltimateCandleTrailingStopMACloudReq;
                checkNTFractals.NumberOfEntrySignals = numberOfEntrySignals;
                numberOfEntrySignals = checkNTFractals.NumberOfEntrySignals;
                checkNTFractals.OverrideEntryPlotColor = overrideEntryPlotColor;
                overrideEntryPlotColor = checkNTFractals.OverrideEntryPlotColor;
                checkNTFractals.Period1 = period1;
                period1 = checkNTFractals.Period1;
                checkNTFractals.Period2 = period2;
                period2 = checkNTFractals.Period2;
                checkNTFractals.ShowReversalEntries = showReversalEntries;
                showReversalEntries = checkNTFractals.ShowReversalEntries;
                checkNTFractals.TextFont = textFont;
                textFont = checkNTFractals.TextFont;
                checkNTFractals.TrailingStopEntry = trailingStopEntry;
                trailingStopEntry = checkNTFractals.TrailingStopEntry;
                checkNTFractals.TrailingStopNLNH = trailingStopNLNH;
                trailingStopNLNH = checkNTFractals.TrailingStopNLNH;
                checkNTFractals.TrailingStopPBS = trailingStopPBS;
                trailingStopPBS = checkNTFractals.TrailingStopPBS;
                checkNTFractals.TrailingStopTicks = trailingStopTicks;
                trailingStopTicks = checkNTFractals.TrailingStopTicks;

                if (cacheNTFractals != null)
                    for (int idx = 0; idx < cacheNTFractals.Length; idx++)
                        if (cacheNTFractals[idx].AlternativeEntryEMAPeriod == alternativeEntryEMAPeriod && cacheNTFractals[idx].AutoStopNLNH == autoStopNLNH && cacheNTFractals[idx].AutoStopNLNHTicks == autoStopNLNHTicks && cacheNTFractals[idx].FirstEntrySignal == firstEntrySignal && cacheNTFractals[idx].ImplementNCTZ == implementNCTZ && cacheNTFractals[idx].InitialStopTicks == initialStopTicks && cacheNTFractals[idx].LetterDisplayOptions == letterDisplayOptions && cacheNTFractals[idx].LineDisplayOptions == lineDisplayOptions && cacheNTFractals[idx].MAType1 == mAType1 && cacheNTFractals[idx].MAType2 == mAType2 && cacheNTFractals[idx].NTDeltaCrossEntryFilter == nTDeltaCrossEntryFilter && cacheNTFractals[idx].NTDeltaCrossTrailingStopFilter == nTDeltaCrossTrailingStopFilter && cacheNTFractals[idx].NTFractalsDeltaCrossEntryOption == nTFractalsDeltaCrossEntryOption && cacheNTFractals[idx].NTFractalsDeltaCrossTrailingStopOption == nTFractalsDeltaCrossTrailingStopOption && cacheNTFractals[idx].NTFractalsUltimateCandleEntryOption == nTFractalsUltimateCandleEntryOption && cacheNTFractals[idx].NTFractalsUltimateCandleTrailingStopOption == nTFractalsUltimateCandleTrailingStopOption && cacheNTFractals[idx].NTMACloudEntryFilter == nTMACloudEntryFilter && cacheNTFractals[idx].NTUltimateCandleEntryFilter == nTUltimateCandleEntryFilter && cacheNTFractals[idx].NTUltimateCandleFilterNTMACloudReqEMAPeriod == nTUltimateCandleFilterNTMACloudReqEMAPeriod && cacheNTFractals[idx].NTUltimateCandleNTDeltaCrossTrailingStopCombo == nTUltimateCandleNTDeltaCrossTrailingStopCombo && cacheNTFractals[idx].NTUltimateCandleTrailingStopFilter == nTUltimateCandleTrailingStopFilter && cacheNTFractals[idx].NTUltimateCandleTrailingStopMACloudReq == nTUltimateCandleTrailingStopMACloudReq && cacheNTFractals[idx].NumberOfEntrySignals == numberOfEntrySignals && cacheNTFractals[idx].OverrideEntryPlotColor == overrideEntryPlotColor && cacheNTFractals[idx].Period1 == period1 && cacheNTFractals[idx].Period2 == period2 && cacheNTFractals[idx].ShowReversalEntries == showReversalEntries && cacheNTFractals[idx].TextFont == textFont && cacheNTFractals[idx].TrailingStopEntry == trailingStopEntry && cacheNTFractals[idx].TrailingStopNLNH == trailingStopNLNH && cacheNTFractals[idx].TrailingStopPBS == trailingStopPBS && cacheNTFractals[idx].TrailingStopTicks == trailingStopTicks && cacheNTFractals[idx].EqualsInput(input))
                            return cacheNTFractals[idx];

                NTFractals indicator = new NTFractals();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AlternativeEntryEMAPeriod = alternativeEntryEMAPeriod;
                indicator.AutoStopNLNH = autoStopNLNH;
                indicator.AutoStopNLNHTicks = autoStopNLNHTicks;
                indicator.FirstEntrySignal = firstEntrySignal;
                indicator.ImplementNCTZ = implementNCTZ;
                indicator.InitialStopTicks = initialStopTicks;
                indicator.LetterDisplayOptions = letterDisplayOptions;
                indicator.LineDisplayOptions = lineDisplayOptions;
                indicator.MAType1 = mAType1;
                indicator.MAType2 = mAType2;
                indicator.NTDeltaCrossEntryFilter = nTDeltaCrossEntryFilter;
                indicator.NTDeltaCrossTrailingStopFilter = nTDeltaCrossTrailingStopFilter;
                indicator.NTFractalsDeltaCrossEntryOption = nTFractalsDeltaCrossEntryOption;
                indicator.NTFractalsDeltaCrossTrailingStopOption = nTFractalsDeltaCrossTrailingStopOption;
                indicator.NTFractalsUltimateCandleEntryOption = nTFractalsUltimateCandleEntryOption;
                indicator.NTFractalsUltimateCandleTrailingStopOption = nTFractalsUltimateCandleTrailingStopOption;
                indicator.NTMACloudEntryFilter = nTMACloudEntryFilter;
                indicator.NTUltimateCandleEntryFilter = nTUltimateCandleEntryFilter;
                indicator.NTUltimateCandleFilterNTMACloudReqEMAPeriod = nTUltimateCandleFilterNTMACloudReqEMAPeriod;
                indicator.NTUltimateCandleNTDeltaCrossTrailingStopCombo = nTUltimateCandleNTDeltaCrossTrailingStopCombo;
                indicator.NTUltimateCandleTrailingStopFilter = nTUltimateCandleTrailingStopFilter;
                indicator.NTUltimateCandleTrailingStopMACloudReq = nTUltimateCandleTrailingStopMACloudReq;
                indicator.NumberOfEntrySignals = numberOfEntrySignals;
                indicator.OverrideEntryPlotColor = overrideEntryPlotColor;
                indicator.Period1 = period1;
                indicator.Period2 = period2;
                indicator.ShowReversalEntries = showReversalEntries;
                indicator.TextFont = textFont;
                indicator.TrailingStopEntry = trailingStopEntry;
                indicator.TrailingStopNLNH = trailingStopNLNH;
                indicator.TrailingStopPBS = trailingStopPBS;
                indicator.TrailingStopTicks = trailingStopTicks;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTFractals[] tmp = new NTFractals[cacheNTFractals == null ? 1 : cacheNTFractals.Length + 1];
                if (cacheNTFractals != null)
                    cacheNTFractals.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTFractals = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTMACloud NTMACloud(int cloudOpacity, Color downCloudColor, NTMACloudMAType mAType1, NTMACloudMAType mAType2, int period1, int period2, Color upCloudColor)
        {
            return NTMACloud(Input, cloudOpacity, downCloudColor, mAType1, mAType2, period1, period2, upCloudColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTMACloud NTMACloud(Data.IDataSeries input, int cloudOpacity, Color downCloudColor, NTMACloudMAType mAType1, NTMACloudMAType mAType2, int period1, int period2, Color upCloudColor)
        {
            if (cacheNTMACloud != null)
                for (int idx = 0; idx < cacheNTMACloud.Length; idx++)
                    if (cacheNTMACloud[idx].CloudOpacity == cloudOpacity && cacheNTMACloud[idx].DownCloudColor == downCloudColor && cacheNTMACloud[idx].MAType1 == mAType1 && cacheNTMACloud[idx].MAType2 == mAType2 && cacheNTMACloud[idx].Period1 == period1 && cacheNTMACloud[idx].Period2 == period2 && cacheNTMACloud[idx].UpCloudColor == upCloudColor && cacheNTMACloud[idx].EqualsInput(input))
                        return cacheNTMACloud[idx];

            lock (checkNTMACloud)
            {
                checkNTMACloud.CloudOpacity = cloudOpacity;
                cloudOpacity = checkNTMACloud.CloudOpacity;
                checkNTMACloud.DownCloudColor = downCloudColor;
                downCloudColor = checkNTMACloud.DownCloudColor;
                checkNTMACloud.MAType1 = mAType1;
                mAType1 = checkNTMACloud.MAType1;
                checkNTMACloud.MAType2 = mAType2;
                mAType2 = checkNTMACloud.MAType2;
                checkNTMACloud.Period1 = period1;
                period1 = checkNTMACloud.Period1;
                checkNTMACloud.Period2 = period2;
                period2 = checkNTMACloud.Period2;
                checkNTMACloud.UpCloudColor = upCloudColor;
                upCloudColor = checkNTMACloud.UpCloudColor;

                if (cacheNTMACloud != null)
                    for (int idx = 0; idx < cacheNTMACloud.Length; idx++)
                        if (cacheNTMACloud[idx].CloudOpacity == cloudOpacity && cacheNTMACloud[idx].DownCloudColor == downCloudColor && cacheNTMACloud[idx].MAType1 == mAType1 && cacheNTMACloud[idx].MAType2 == mAType2 && cacheNTMACloud[idx].Period1 == period1 && cacheNTMACloud[idx].Period2 == period2 && cacheNTMACloud[idx].UpCloudColor == upCloudColor && cacheNTMACloud[idx].EqualsInput(input))
                            return cacheNTMACloud[idx];

                NTMACloud indicator = new NTMACloud();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.CloudOpacity = cloudOpacity;
                indicator.DownCloudColor = downCloudColor;
                indicator.MAType1 = mAType1;
                indicator.MAType2 = mAType2;
                indicator.Period1 = period1;
                indicator.Period2 = period2;
                indicator.UpCloudColor = upCloudColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTMACloud[] tmp = new NTMACloud[cacheNTMACloud == null ? 1 : cacheNTMACloud.Length + 1];
                if (cacheNTMACloud != null)
                    cacheNTMACloud.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTMACloud = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// NewbieTrader.com - Color the background of a chart during specified input times
        /// </summary>
        /// <returns></returns>
        public NTTimeBlock NTTimeBlock(int end, int start, Color timeSpanColor1)
        {
            return NTTimeBlock(Input, end, start, timeSpanColor1);
        }

        /// <summary>
        /// NewbieTrader.com - Color the background of a chart during specified input times
        /// </summary>
        /// <returns></returns>
        public NTTimeBlock NTTimeBlock(Data.IDataSeries input, int end, int start, Color timeSpanColor1)
        {
            if (cacheNTTimeBlock != null)
                for (int idx = 0; idx < cacheNTTimeBlock.Length; idx++)
                    if (cacheNTTimeBlock[idx].End == end && cacheNTTimeBlock[idx].Start == start && cacheNTTimeBlock[idx].TimeSpanColor1 == timeSpanColor1 && cacheNTTimeBlock[idx].EqualsInput(input))
                        return cacheNTTimeBlock[idx];

            lock (checkNTTimeBlock)
            {
                checkNTTimeBlock.End = end;
                end = checkNTTimeBlock.End;
                checkNTTimeBlock.Start = start;
                start = checkNTTimeBlock.Start;
                checkNTTimeBlock.TimeSpanColor1 = timeSpanColor1;
                timeSpanColor1 = checkNTTimeBlock.TimeSpanColor1;

                if (cacheNTTimeBlock != null)
                    for (int idx = 0; idx < cacheNTTimeBlock.Length; idx++)
                        if (cacheNTTimeBlock[idx].End == end && cacheNTTimeBlock[idx].Start == start && cacheNTTimeBlock[idx].TimeSpanColor1 == timeSpanColor1 && cacheNTTimeBlock[idx].EqualsInput(input))
                            return cacheNTTimeBlock[idx];

                NTTimeBlock indicator = new NTTimeBlock();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.End = end;
                indicator.Start = start;
                indicator.TimeSpanColor1 = timeSpanColor1;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTTimeBlock[] tmp = new NTTimeBlock[cacheNTTimeBlock == null ? 1 : cacheNTTimeBlock.Length + 1];
                if (cacheNTTimeBlock != null)
                    cacheNTTimeBlock.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTTimeBlock = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandle6E NTUltimateCandle6E(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return NTUltimateCandle6E(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandle6E NTUltimateCandle6E(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (cacheNTUltimateCandle6E != null)
                for (int idx = 0; idx < cacheNTUltimateCandle6E.Length; idx++)
                    if (cacheNTUltimateCandle6E[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandle6E[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandle6E[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandle6E[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandle6E[idx].NeutralColor == neutralColor && cacheNTUltimateCandle6E[idx].EqualsInput(input))
                        return cacheNTUltimateCandle6E[idx];

            lock (checkNTUltimateCandle6E)
            {
                checkNTUltimateCandle6E.Bearish3Color = bearish3Color;
                bearish3Color = checkNTUltimateCandle6E.Bearish3Color;
                checkNTUltimateCandle6E.Bearish4Color = bearish4Color;
                bearish4Color = checkNTUltimateCandle6E.Bearish4Color;
                checkNTUltimateCandle6E.Bullish3Color = bullish3Color;
                bullish3Color = checkNTUltimateCandle6E.Bullish3Color;
                checkNTUltimateCandle6E.Bullish4Color = bullish4Color;
                bullish4Color = checkNTUltimateCandle6E.Bullish4Color;
                checkNTUltimateCandle6E.NeutralColor = neutralColor;
                neutralColor = checkNTUltimateCandle6E.NeutralColor;

                if (cacheNTUltimateCandle6E != null)
                    for (int idx = 0; idx < cacheNTUltimateCandle6E.Length; idx++)
                        if (cacheNTUltimateCandle6E[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandle6E[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandle6E[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandle6E[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandle6E[idx].NeutralColor == neutralColor && cacheNTUltimateCandle6E[idx].EqualsInput(input))
                            return cacheNTUltimateCandle6E[idx];

                NTUltimateCandle6E indicator = new NTUltimateCandle6E();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bearish3Color = bearish3Color;
                indicator.Bearish4Color = bearish4Color;
                indicator.Bullish3Color = bullish3Color;
                indicator.Bullish4Color = bullish4Color;
                indicator.NeutralColor = neutralColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandle6E[] tmp = new NTUltimateCandle6E[cacheNTUltimateCandle6E == null ? 1 : cacheNTUltimateCandle6E.Length + 1];
                if (cacheNTUltimateCandle6E != null)
                    cacheNTUltimateCandle6E.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandle6E = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleCL NTUltimateCandleCL(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return NTUltimateCandleCL(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleCL NTUltimateCandleCL(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (cacheNTUltimateCandleCL != null)
                for (int idx = 0; idx < cacheNTUltimateCandleCL.Length; idx++)
                    if (cacheNTUltimateCandleCL[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleCL[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleCL[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleCL[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleCL[idx].NeutralColor == neutralColor && cacheNTUltimateCandleCL[idx].EqualsInput(input))
                        return cacheNTUltimateCandleCL[idx];

            lock (checkNTUltimateCandleCL)
            {
                checkNTUltimateCandleCL.Bearish3Color = bearish3Color;
                bearish3Color = checkNTUltimateCandleCL.Bearish3Color;
                checkNTUltimateCandleCL.Bearish4Color = bearish4Color;
                bearish4Color = checkNTUltimateCandleCL.Bearish4Color;
                checkNTUltimateCandleCL.Bullish3Color = bullish3Color;
                bullish3Color = checkNTUltimateCandleCL.Bullish3Color;
                checkNTUltimateCandleCL.Bullish4Color = bullish4Color;
                bullish4Color = checkNTUltimateCandleCL.Bullish4Color;
                checkNTUltimateCandleCL.NeutralColor = neutralColor;
                neutralColor = checkNTUltimateCandleCL.NeutralColor;

                if (cacheNTUltimateCandleCL != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleCL.Length; idx++)
                        if (cacheNTUltimateCandleCL[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleCL[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleCL[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleCL[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleCL[idx].NeutralColor == neutralColor && cacheNTUltimateCandleCL[idx].EqualsInput(input))
                            return cacheNTUltimateCandleCL[idx];

                NTUltimateCandleCL indicator = new NTUltimateCandleCL();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bearish3Color = bearish3Color;
                indicator.Bearish4Color = bearish4Color;
                indicator.Bullish3Color = bullish3Color;
                indicator.Bullish4Color = bullish4Color;
                indicator.NeutralColor = neutralColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleCL[] tmp = new NTUltimateCandleCL[cacheNTUltimateCandleCL == null ? 1 : cacheNTUltimateCandleCL.Length + 1];
                if (cacheNTUltimateCandleCL != null)
                    cacheNTUltimateCandleCL.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleCL = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleES NTUltimateCandleES(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return NTUltimateCandleES(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleES NTUltimateCandleES(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (cacheNTUltimateCandleES != null)
                for (int idx = 0; idx < cacheNTUltimateCandleES.Length; idx++)
                    if (cacheNTUltimateCandleES[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleES[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleES[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleES[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleES[idx].NeutralColor == neutralColor && cacheNTUltimateCandleES[idx].EqualsInput(input))
                        return cacheNTUltimateCandleES[idx];

            lock (checkNTUltimateCandleES)
            {
                checkNTUltimateCandleES.Bearish3Color = bearish3Color;
                bearish3Color = checkNTUltimateCandleES.Bearish3Color;
                checkNTUltimateCandleES.Bearish4Color = bearish4Color;
                bearish4Color = checkNTUltimateCandleES.Bearish4Color;
                checkNTUltimateCandleES.Bullish3Color = bullish3Color;
                bullish3Color = checkNTUltimateCandleES.Bullish3Color;
                checkNTUltimateCandleES.Bullish4Color = bullish4Color;
                bullish4Color = checkNTUltimateCandleES.Bullish4Color;
                checkNTUltimateCandleES.NeutralColor = neutralColor;
                neutralColor = checkNTUltimateCandleES.NeutralColor;

                if (cacheNTUltimateCandleES != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleES.Length; idx++)
                        if (cacheNTUltimateCandleES[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleES[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleES[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleES[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleES[idx].NeutralColor == neutralColor && cacheNTUltimateCandleES[idx].EqualsInput(input))
                            return cacheNTUltimateCandleES[idx];

                NTUltimateCandleES indicator = new NTUltimateCandleES();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bearish3Color = bearish3Color;
                indicator.Bearish4Color = bearish4Color;
                indicator.Bullish3Color = bullish3Color;
                indicator.Bullish4Color = bullish4Color;
                indicator.NeutralColor = neutralColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleES[] tmp = new NTUltimateCandleES[cacheNTUltimateCandleES == null ? 1 : cacheNTUltimateCandleES.Length + 1];
                if (cacheNTUltimateCandleES != null)
                    cacheNTUltimateCandleES.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleES = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleGC NTUltimateCandleGC(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return NTUltimateCandleGC(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleGC NTUltimateCandleGC(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (cacheNTUltimateCandleGC != null)
                for (int idx = 0; idx < cacheNTUltimateCandleGC.Length; idx++)
                    if (cacheNTUltimateCandleGC[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleGC[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleGC[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleGC[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleGC[idx].NeutralColor == neutralColor && cacheNTUltimateCandleGC[idx].EqualsInput(input))
                        return cacheNTUltimateCandleGC[idx];

            lock (checkNTUltimateCandleGC)
            {
                checkNTUltimateCandleGC.Bearish3Color = bearish3Color;
                bearish3Color = checkNTUltimateCandleGC.Bearish3Color;
                checkNTUltimateCandleGC.Bearish4Color = bearish4Color;
                bearish4Color = checkNTUltimateCandleGC.Bearish4Color;
                checkNTUltimateCandleGC.Bullish3Color = bullish3Color;
                bullish3Color = checkNTUltimateCandleGC.Bullish3Color;
                checkNTUltimateCandleGC.Bullish4Color = bullish4Color;
                bullish4Color = checkNTUltimateCandleGC.Bullish4Color;
                checkNTUltimateCandleGC.NeutralColor = neutralColor;
                neutralColor = checkNTUltimateCandleGC.NeutralColor;

                if (cacheNTUltimateCandleGC != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleGC.Length; idx++)
                        if (cacheNTUltimateCandleGC[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleGC[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleGC[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleGC[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleGC[idx].NeutralColor == neutralColor && cacheNTUltimateCandleGC[idx].EqualsInput(input))
                            return cacheNTUltimateCandleGC[idx];

                NTUltimateCandleGC indicator = new NTUltimateCandleGC();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bearish3Color = bearish3Color;
                indicator.Bearish4Color = bearish4Color;
                indicator.Bullish3Color = bullish3Color;
                indicator.Bullish4Color = bullish4Color;
                indicator.NeutralColor = neutralColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleGC[] tmp = new NTUltimateCandleGC[cacheNTUltimateCandleGC == null ? 1 : cacheNTUltimateCandleGC.Length + 1];
                if (cacheNTUltimateCandleGC != null)
                    cacheNTUltimateCandleGC.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleGC = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleHelper NTUltimateCandleHelper()
        {
            return NTUltimateCandleHelper(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleHelper NTUltimateCandleHelper(Data.IDataSeries input)
        {
            if (cacheNTUltimateCandleHelper != null)
                for (int idx = 0; idx < cacheNTUltimateCandleHelper.Length; idx++)
                    if (cacheNTUltimateCandleHelper[idx].EqualsInput(input))
                        return cacheNTUltimateCandleHelper[idx];

            lock (checkNTUltimateCandleHelper)
            {
                if (cacheNTUltimateCandleHelper != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleHelper.Length; idx++)
                        if (cacheNTUltimateCandleHelper[idx].EqualsInput(input))
                            return cacheNTUltimateCandleHelper[idx];

                NTUltimateCandleHelper indicator = new NTUltimateCandleHelper();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleHelper[] tmp = new NTUltimateCandleHelper[cacheNTUltimateCandleHelper == null ? 1 : cacheNTUltimateCandleHelper.Length + 1];
                if (cacheNTUltimateCandleHelper != null)
                    cacheNTUltimateCandleHelper.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleHelper = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleHelperES NTUltimateCandleHelperES()
        {
            return NTUltimateCandleHelperES(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleHelperES NTUltimateCandleHelperES(Data.IDataSeries input)
        {
            if (cacheNTUltimateCandleHelperES != null)
                for (int idx = 0; idx < cacheNTUltimateCandleHelperES.Length; idx++)
                    if (cacheNTUltimateCandleHelperES[idx].EqualsInput(input))
                        return cacheNTUltimateCandleHelperES[idx];

            lock (checkNTUltimateCandleHelperES)
            {
                if (cacheNTUltimateCandleHelperES != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleHelperES.Length; idx++)
                        if (cacheNTUltimateCandleHelperES[idx].EqualsInput(input))
                            return cacheNTUltimateCandleHelperES[idx];

                NTUltimateCandleHelperES indicator = new NTUltimateCandleHelperES();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleHelperES[] tmp = new NTUltimateCandleHelperES[cacheNTUltimateCandleHelperES == null ? 1 : cacheNTUltimateCandleHelperES.Length + 1];
                if (cacheNTUltimateCandleHelperES != null)
                    cacheNTUltimateCandleHelperES.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleHelperES = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleHG NTUltimateCandleHG(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return NTUltimateCandleHG(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleHG NTUltimateCandleHG(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (cacheNTUltimateCandleHG != null)
                for (int idx = 0; idx < cacheNTUltimateCandleHG.Length; idx++)
                    if (cacheNTUltimateCandleHG[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleHG[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleHG[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleHG[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleHG[idx].NeutralColor == neutralColor && cacheNTUltimateCandleHG[idx].EqualsInput(input))
                        return cacheNTUltimateCandleHG[idx];

            lock (checkNTUltimateCandleHG)
            {
                checkNTUltimateCandleHG.Bearish3Color = bearish3Color;
                bearish3Color = checkNTUltimateCandleHG.Bearish3Color;
                checkNTUltimateCandleHG.Bearish4Color = bearish4Color;
                bearish4Color = checkNTUltimateCandleHG.Bearish4Color;
                checkNTUltimateCandleHG.Bullish3Color = bullish3Color;
                bullish3Color = checkNTUltimateCandleHG.Bullish3Color;
                checkNTUltimateCandleHG.Bullish4Color = bullish4Color;
                bullish4Color = checkNTUltimateCandleHG.Bullish4Color;
                checkNTUltimateCandleHG.NeutralColor = neutralColor;
                neutralColor = checkNTUltimateCandleHG.NeutralColor;

                if (cacheNTUltimateCandleHG != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleHG.Length; idx++)
                        if (cacheNTUltimateCandleHG[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleHG[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleHG[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleHG[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleHG[idx].NeutralColor == neutralColor && cacheNTUltimateCandleHG[idx].EqualsInput(input))
                            return cacheNTUltimateCandleHG[idx];

                NTUltimateCandleHG indicator = new NTUltimateCandleHG();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bearish3Color = bearish3Color;
                indicator.Bearish4Color = bearish4Color;
                indicator.Bullish3Color = bullish3Color;
                indicator.Bullish4Color = bullish4Color;
                indicator.NeutralColor = neutralColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleHG[] tmp = new NTUltimateCandleHG[cacheNTUltimateCandleHG == null ? 1 : cacheNTUltimateCandleHG.Length + 1];
                if (cacheNTUltimateCandleHG != null)
                    cacheNTUltimateCandleHG.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleHG = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleNG NTUltimateCandleNG(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return NTUltimateCandleNG(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleNG NTUltimateCandleNG(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (cacheNTUltimateCandleNG != null)
                for (int idx = 0; idx < cacheNTUltimateCandleNG.Length; idx++)
                    if (cacheNTUltimateCandleNG[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleNG[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleNG[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleNG[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleNG[idx].NeutralColor == neutralColor && cacheNTUltimateCandleNG[idx].EqualsInput(input))
                        return cacheNTUltimateCandleNG[idx];

            lock (checkNTUltimateCandleNG)
            {
                checkNTUltimateCandleNG.Bearish3Color = bearish3Color;
                bearish3Color = checkNTUltimateCandleNG.Bearish3Color;
                checkNTUltimateCandleNG.Bearish4Color = bearish4Color;
                bearish4Color = checkNTUltimateCandleNG.Bearish4Color;
                checkNTUltimateCandleNG.Bullish3Color = bullish3Color;
                bullish3Color = checkNTUltimateCandleNG.Bullish3Color;
                checkNTUltimateCandleNG.Bullish4Color = bullish4Color;
                bullish4Color = checkNTUltimateCandleNG.Bullish4Color;
                checkNTUltimateCandleNG.NeutralColor = neutralColor;
                neutralColor = checkNTUltimateCandleNG.NeutralColor;

                if (cacheNTUltimateCandleNG != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleNG.Length; idx++)
                        if (cacheNTUltimateCandleNG[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleNG[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleNG[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleNG[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleNG[idx].NeutralColor == neutralColor && cacheNTUltimateCandleNG[idx].EqualsInput(input))
                            return cacheNTUltimateCandleNG[idx];

                NTUltimateCandleNG indicator = new NTUltimateCandleNG();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bearish3Color = bearish3Color;
                indicator.Bearish4Color = bearish4Color;
                indicator.Bullish3Color = bullish3Color;
                indicator.Bullish4Color = bullish4Color;
                indicator.NeutralColor = neutralColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleNG[] tmp = new NTUltimateCandleNG[cacheNTUltimateCandleNG == null ? 1 : cacheNTUltimateCandleNG.Length + 1];
                if (cacheNTUltimateCandleNG != null)
                    cacheNTUltimateCandleNG.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleNG = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleNQ NTUltimateCandleNQ(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return NTUltimateCandleNQ(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleNQ NTUltimateCandleNQ(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (cacheNTUltimateCandleNQ != null)
                for (int idx = 0; idx < cacheNTUltimateCandleNQ.Length; idx++)
                    if (cacheNTUltimateCandleNQ[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleNQ[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleNQ[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleNQ[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleNQ[idx].NeutralColor == neutralColor && cacheNTUltimateCandleNQ[idx].EqualsInput(input))
                        return cacheNTUltimateCandleNQ[idx];

            lock (checkNTUltimateCandleNQ)
            {
                checkNTUltimateCandleNQ.Bearish3Color = bearish3Color;
                bearish3Color = checkNTUltimateCandleNQ.Bearish3Color;
                checkNTUltimateCandleNQ.Bearish4Color = bearish4Color;
                bearish4Color = checkNTUltimateCandleNQ.Bearish4Color;
                checkNTUltimateCandleNQ.Bullish3Color = bullish3Color;
                bullish3Color = checkNTUltimateCandleNQ.Bullish3Color;
                checkNTUltimateCandleNQ.Bullish4Color = bullish4Color;
                bullish4Color = checkNTUltimateCandleNQ.Bullish4Color;
                checkNTUltimateCandleNQ.NeutralColor = neutralColor;
                neutralColor = checkNTUltimateCandleNQ.NeutralColor;

                if (cacheNTUltimateCandleNQ != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleNQ.Length; idx++)
                        if (cacheNTUltimateCandleNQ[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleNQ[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleNQ[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleNQ[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleNQ[idx].NeutralColor == neutralColor && cacheNTUltimateCandleNQ[idx].EqualsInput(input))
                            return cacheNTUltimateCandleNQ[idx];

                NTUltimateCandleNQ indicator = new NTUltimateCandleNQ();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bearish3Color = bearish3Color;
                indicator.Bearish4Color = bearish4Color;
                indicator.Bullish3Color = bullish3Color;
                indicator.Bullish4Color = bullish4Color;
                indicator.NeutralColor = neutralColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleNQ[] tmp = new NTUltimateCandleNQ[cacheNTUltimateCandleNQ == null ? 1 : cacheNTUltimateCandleNQ.Length + 1];
                if (cacheNTUltimateCandleNQ != null)
                    cacheNTUltimateCandleNQ.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleNQ = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleTF NTUltimateCandleTF(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return NTUltimateCandleTF(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleTF NTUltimateCandleTF(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (cacheNTUltimateCandleTF != null)
                for (int idx = 0; idx < cacheNTUltimateCandleTF.Length; idx++)
                    if (cacheNTUltimateCandleTF[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleTF[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleTF[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleTF[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleTF[idx].NeutralColor == neutralColor && cacheNTUltimateCandleTF[idx].EqualsInput(input))
                        return cacheNTUltimateCandleTF[idx];

            lock (checkNTUltimateCandleTF)
            {
                checkNTUltimateCandleTF.Bearish3Color = bearish3Color;
                bearish3Color = checkNTUltimateCandleTF.Bearish3Color;
                checkNTUltimateCandleTF.Bearish4Color = bearish4Color;
                bearish4Color = checkNTUltimateCandleTF.Bearish4Color;
                checkNTUltimateCandleTF.Bullish3Color = bullish3Color;
                bullish3Color = checkNTUltimateCandleTF.Bullish3Color;
                checkNTUltimateCandleTF.Bullish4Color = bullish4Color;
                bullish4Color = checkNTUltimateCandleTF.Bullish4Color;
                checkNTUltimateCandleTF.NeutralColor = neutralColor;
                neutralColor = checkNTUltimateCandleTF.NeutralColor;

                if (cacheNTUltimateCandleTF != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleTF.Length; idx++)
                        if (cacheNTUltimateCandleTF[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleTF[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleTF[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleTF[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleTF[idx].NeutralColor == neutralColor && cacheNTUltimateCandleTF[idx].EqualsInput(input))
                            return cacheNTUltimateCandleTF[idx];

                NTUltimateCandleTF indicator = new NTUltimateCandleTF();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bearish3Color = bearish3Color;
                indicator.Bearish4Color = bearish4Color;
                indicator.Bullish3Color = bullish3Color;
                indicator.Bullish4Color = bullish4Color;
                indicator.NeutralColor = neutralColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleTF[] tmp = new NTUltimateCandleTF[cacheNTUltimateCandleTF == null ? 1 : cacheNTUltimateCandleTF.Length + 1];
                if (cacheNTUltimateCandleTF != null)
                    cacheNTUltimateCandleTF.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleTF = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleYM NTUltimateCandleYM(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return NTUltimateCandleYM(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleYM NTUltimateCandleYM(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (cacheNTUltimateCandleYM != null)
                for (int idx = 0; idx < cacheNTUltimateCandleYM.Length; idx++)
                    if (cacheNTUltimateCandleYM[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleYM[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleYM[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleYM[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleYM[idx].NeutralColor == neutralColor && cacheNTUltimateCandleYM[idx].EqualsInput(input))
                        return cacheNTUltimateCandleYM[idx];

            lock (checkNTUltimateCandleYM)
            {
                checkNTUltimateCandleYM.Bearish3Color = bearish3Color;
                bearish3Color = checkNTUltimateCandleYM.Bearish3Color;
                checkNTUltimateCandleYM.Bearish4Color = bearish4Color;
                bearish4Color = checkNTUltimateCandleYM.Bearish4Color;
                checkNTUltimateCandleYM.Bullish3Color = bullish3Color;
                bullish3Color = checkNTUltimateCandleYM.Bullish3Color;
                checkNTUltimateCandleYM.Bullish4Color = bullish4Color;
                bullish4Color = checkNTUltimateCandleYM.Bullish4Color;
                checkNTUltimateCandleYM.NeutralColor = neutralColor;
                neutralColor = checkNTUltimateCandleYM.NeutralColor;

                if (cacheNTUltimateCandleYM != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleYM.Length; idx++)
                        if (cacheNTUltimateCandleYM[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleYM[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleYM[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleYM[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleYM[idx].NeutralColor == neutralColor && cacheNTUltimateCandleYM[idx].EqualsInput(input))
                            return cacheNTUltimateCandleYM[idx];

                NTUltimateCandleYM indicator = new NTUltimateCandleYM();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bearish3Color = bearish3Color;
                indicator.Bearish4Color = bearish4Color;
                indicator.Bullish3Color = bullish3Color;
                indicator.Bullish4Color = bullish4Color;
                indicator.NeutralColor = neutralColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleYM[] tmp = new NTUltimateCandleYM[cacheNTUltimateCandleYM == null ? 1 : cacheNTUltimateCandleYM.Length + 1];
                if (cacheNTUltimateCandleYM != null)
                    cacheNTUltimateCandleYM.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleYM = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleZ NTUltimateCandleZ(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return NTUltimateCandleZ(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleZ NTUltimateCandleZ(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (cacheNTUltimateCandleZ != null)
                for (int idx = 0; idx < cacheNTUltimateCandleZ.Length; idx++)
                    if (cacheNTUltimateCandleZ[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleZ[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleZ[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleZ[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleZ[idx].NeutralColor == neutralColor && cacheNTUltimateCandleZ[idx].EqualsInput(input))
                        return cacheNTUltimateCandleZ[idx];

            lock (checkNTUltimateCandleZ)
            {
                checkNTUltimateCandleZ.Bearish3Color = bearish3Color;
                bearish3Color = checkNTUltimateCandleZ.Bearish3Color;
                checkNTUltimateCandleZ.Bearish4Color = bearish4Color;
                bearish4Color = checkNTUltimateCandleZ.Bearish4Color;
                checkNTUltimateCandleZ.Bullish3Color = bullish3Color;
                bullish3Color = checkNTUltimateCandleZ.Bullish3Color;
                checkNTUltimateCandleZ.Bullish4Color = bullish4Color;
                bullish4Color = checkNTUltimateCandleZ.Bullish4Color;
                checkNTUltimateCandleZ.NeutralColor = neutralColor;
                neutralColor = checkNTUltimateCandleZ.NeutralColor;

                if (cacheNTUltimateCandleZ != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleZ.Length; idx++)
                        if (cacheNTUltimateCandleZ[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleZ[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleZ[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleZ[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleZ[idx].NeutralColor == neutralColor && cacheNTUltimateCandleZ[idx].EqualsInput(input))
                            return cacheNTUltimateCandleZ[idx];

                NTUltimateCandleZ indicator = new NTUltimateCandleZ();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bearish3Color = bearish3Color;
                indicator.Bearish4Color = bearish4Color;
                indicator.Bullish3Color = bullish3Color;
                indicator.Bullish4Color = bullish4Color;
                indicator.NeutralColor = neutralColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleZ[] tmp = new NTUltimateCandleZ[cacheNTUltimateCandleZ == null ? 1 : cacheNTUltimateCandleZ.Length + 1];
                if (cacheNTUltimateCandleZ != null)
                    cacheNTUltimateCandleZ.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleZ = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleZC NTUltimateCandleZC(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return NTUltimateCandleZC(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleZC NTUltimateCandleZC(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (cacheNTUltimateCandleZC != null)
                for (int idx = 0; idx < cacheNTUltimateCandleZC.Length; idx++)
                    if (cacheNTUltimateCandleZC[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleZC[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleZC[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleZC[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleZC[idx].NeutralColor == neutralColor && cacheNTUltimateCandleZC[idx].EqualsInput(input))
                        return cacheNTUltimateCandleZC[idx];

            lock (checkNTUltimateCandleZC)
            {
                checkNTUltimateCandleZC.Bearish3Color = bearish3Color;
                bearish3Color = checkNTUltimateCandleZC.Bearish3Color;
                checkNTUltimateCandleZC.Bearish4Color = bearish4Color;
                bearish4Color = checkNTUltimateCandleZC.Bearish4Color;
                checkNTUltimateCandleZC.Bullish3Color = bullish3Color;
                bullish3Color = checkNTUltimateCandleZC.Bullish3Color;
                checkNTUltimateCandleZC.Bullish4Color = bullish4Color;
                bullish4Color = checkNTUltimateCandleZC.Bullish4Color;
                checkNTUltimateCandleZC.NeutralColor = neutralColor;
                neutralColor = checkNTUltimateCandleZC.NeutralColor;

                if (cacheNTUltimateCandleZC != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleZC.Length; idx++)
                        if (cacheNTUltimateCandleZC[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleZC[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleZC[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleZC[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleZC[idx].NeutralColor == neutralColor && cacheNTUltimateCandleZC[idx].EqualsInput(input))
                            return cacheNTUltimateCandleZC[idx];

                NTUltimateCandleZC indicator = new NTUltimateCandleZC();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bearish3Color = bearish3Color;
                indicator.Bearish4Color = bearish4Color;
                indicator.Bullish3Color = bullish3Color;
                indicator.Bullish4Color = bullish4Color;
                indicator.NeutralColor = neutralColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleZC[] tmp = new NTUltimateCandleZC[cacheNTUltimateCandleZC == null ? 1 : cacheNTUltimateCandleZC.Length + 1];
                if (cacheNTUltimateCandleZC != null)
                    cacheNTUltimateCandleZC.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleZC = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleZS NTUltimateCandleZS(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return NTUltimateCandleZS(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public NTUltimateCandleZS NTUltimateCandleZS(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (cacheNTUltimateCandleZS != null)
                for (int idx = 0; idx < cacheNTUltimateCandleZS.Length; idx++)
                    if (cacheNTUltimateCandleZS[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleZS[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleZS[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleZS[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleZS[idx].NeutralColor == neutralColor && cacheNTUltimateCandleZS[idx].EqualsInput(input))
                        return cacheNTUltimateCandleZS[idx];

            lock (checkNTUltimateCandleZS)
            {
                checkNTUltimateCandleZS.Bearish3Color = bearish3Color;
                bearish3Color = checkNTUltimateCandleZS.Bearish3Color;
                checkNTUltimateCandleZS.Bearish4Color = bearish4Color;
                bearish4Color = checkNTUltimateCandleZS.Bearish4Color;
                checkNTUltimateCandleZS.Bullish3Color = bullish3Color;
                bullish3Color = checkNTUltimateCandleZS.Bullish3Color;
                checkNTUltimateCandleZS.Bullish4Color = bullish4Color;
                bullish4Color = checkNTUltimateCandleZS.Bullish4Color;
                checkNTUltimateCandleZS.NeutralColor = neutralColor;
                neutralColor = checkNTUltimateCandleZS.NeutralColor;

                if (cacheNTUltimateCandleZS != null)
                    for (int idx = 0; idx < cacheNTUltimateCandleZS.Length; idx++)
                        if (cacheNTUltimateCandleZS[idx].Bearish3Color == bearish3Color && cacheNTUltimateCandleZS[idx].Bearish4Color == bearish4Color && cacheNTUltimateCandleZS[idx].Bullish3Color == bullish3Color && cacheNTUltimateCandleZS[idx].Bullish4Color == bullish4Color && cacheNTUltimateCandleZS[idx].NeutralColor == neutralColor && cacheNTUltimateCandleZS[idx].EqualsInput(input))
                            return cacheNTUltimateCandleZS[idx];

                NTUltimateCandleZS indicator = new NTUltimateCandleZS();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Bearish3Color = bearish3Color;
                indicator.Bearish4Color = bearish4Color;
                indicator.Bullish3Color = bullish3Color;
                indicator.Bullish4Color = bullish4Color;
                indicator.NeutralColor = neutralColor;
                Indicators.Add(indicator);
                indicator.SetUp();

                NTUltimateCandleZS[] tmp = new NTUltimateCandleZS[cacheNTUltimateCandleZS == null ? 1 : cacheNTUltimateCandleZS.Length + 1];
                if (cacheNTUltimateCandleZS != null)
                    cacheNTUltimateCandleZS.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheNTUltimateCandleZS = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        ///  The squeeze indicator shows when the Bollinger Bands are contracting stronger than a Keltner Channel.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.anaSqueeze anaSqueeze(double numMultiplier, double numStdDev, int period)
        {
            return _indicator.anaSqueeze(Input, numMultiplier, numStdDev, period);
        }

        /// <summary>
        ///  The squeeze indicator shows when the Bollinger Bands are contracting stronger than a Keltner Channel.
        /// </summary>
        /// <returns></returns>
        public Indicator.anaSqueeze anaSqueeze(Data.IDataSeries input, double numMultiplier, double numStdDev, int period)
        {
            return _indicator.anaSqueeze(input, numMultiplier, numStdDev, period);
        }

        /// <summary>
        ///  The squeeze indicator shows when the Bollinger Bands are contracting stronger than a Keltner Channel.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTChops NTChops(double numMultiplier, double numStdDev, int period)
        {
            return _indicator.NTChops(Input, numMultiplier, numStdDev, period);
        }

        /// <summary>
        ///  The squeeze indicator shows when the Bollinger Bands are contracting stronger than a Keltner Channel.
        /// </summary>
        /// <returns></returns>
        public Indicator.NTChops NTChops(Data.IDataSeries input, double numMultiplier, double numStdDev, int period)
        {
            return _indicator.NTChops(input, numMultiplier, numStdDev, period);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCross6E NTDeltaCross6E()
        {
            return _indicator.NTDeltaCross6E(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCross6E NTDeltaCross6E(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCross6E(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossADD NTDeltaCrossADD()
        {
            return _indicator.NTDeltaCrossADD(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossADD NTDeltaCrossADD(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCrossADD(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossCL NTDeltaCrossCL()
        {
            return _indicator.NTDeltaCrossCL(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossCL NTDeltaCrossCL(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCrossCL(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossES NTDeltaCrossES()
        {
            return _indicator.NTDeltaCrossES(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossES NTDeltaCrossES(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCrossES(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossGC NTDeltaCrossGC()
        {
            return _indicator.NTDeltaCrossGC(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossGC NTDeltaCrossGC(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCrossGC(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossHG NTDeltaCrossHG()
        {
            return _indicator.NTDeltaCrossHG(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossHG NTDeltaCrossHG(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCrossHG(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossNG NTDeltaCrossNG()
        {
            return _indicator.NTDeltaCrossNG(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossNG NTDeltaCrossNG(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCrossNG(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossNQ NTDeltaCrossNQ()
        {
            return _indicator.NTDeltaCrossNQ(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossNQ NTDeltaCrossNQ(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCrossNQ(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossTF NTDeltaCrossTF()
        {
            return _indicator.NTDeltaCrossTF(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossTF NTDeltaCrossTF(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCrossTF(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossYM NTDeltaCrossYM()
        {
            return _indicator.NTDeltaCrossYM(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossYM NTDeltaCrossYM(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCrossYM(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossZ NTDeltaCrossZ()
        {
            return _indicator.NTDeltaCrossZ(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossZ NTDeltaCrossZ(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCrossZ(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossZC NTDeltaCrossZC()
        {
            return _indicator.NTDeltaCrossZC(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossZC NTDeltaCrossZC(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCrossZC(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossZS NTDeltaCrossZS()
        {
            return _indicator.NTDeltaCrossZS(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossZS NTDeltaCrossZS(Data.IDataSeries input)
        {
            return _indicator.NTDeltaCrossZS(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTFractals NTFractals(int alternativeEntryEMAPeriod, bool autoStopNLNH, int autoStopNLNHTicks, NTFractalsFirstEntrySignal firstEntrySignal, bool implementNCTZ, int initialStopTicks, NTFractalsLetterDisplayOptions letterDisplayOptions, NTFractalsLineDisplayOptions lineDisplayOptions, NTMACloudMAType mAType1, NTMACloudMAType mAType2, bool nTDeltaCrossEntryFilter, bool nTDeltaCrossTrailingStopFilter, NTFractalsDeltaCrossOptions nTFractalsDeltaCrossEntryOption, NTFractalsDeltaCrossOptions nTFractalsDeltaCrossTrailingStopOption, NTFractalsUltimateCandleOptions nTFractalsUltimateCandleEntryOption, NTFractalsUltimateCandleOptions nTFractalsUltimateCandleTrailingStopOption, bool nTMACloudEntryFilter, bool nTUltimateCandleEntryFilter, int nTUltimateCandleFilterNTMACloudReqEMAPeriod, bool nTUltimateCandleNTDeltaCrossTrailingStopCombo, bool nTUltimateCandleTrailingStopFilter, bool nTUltimateCandleTrailingStopMACloudReq, NTFractalsNumberOfEntrySignals numberOfEntrySignals, bool overrideEntryPlotColor, int period1, int period2, bool showReversalEntries, Font textFont, bool trailingStopEntry, bool trailingStopNLNH, bool trailingStopPBS, int trailingStopTicks)
        {
            return _indicator.NTFractals(Input, alternativeEntryEMAPeriod, autoStopNLNH, autoStopNLNHTicks, firstEntrySignal, implementNCTZ, initialStopTicks, letterDisplayOptions, lineDisplayOptions, mAType1, mAType2, nTDeltaCrossEntryFilter, nTDeltaCrossTrailingStopFilter, nTFractalsDeltaCrossEntryOption, nTFractalsDeltaCrossTrailingStopOption, nTFractalsUltimateCandleEntryOption, nTFractalsUltimateCandleTrailingStopOption, nTMACloudEntryFilter, nTUltimateCandleEntryFilter, nTUltimateCandleFilterNTMACloudReqEMAPeriod, nTUltimateCandleNTDeltaCrossTrailingStopCombo, nTUltimateCandleTrailingStopFilter, nTUltimateCandleTrailingStopMACloudReq, numberOfEntrySignals, overrideEntryPlotColor, period1, period2, showReversalEntries, textFont, trailingStopEntry, trailingStopNLNH, trailingStopPBS, trailingStopTicks);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTFractals NTFractals(Data.IDataSeries input, int alternativeEntryEMAPeriod, bool autoStopNLNH, int autoStopNLNHTicks, NTFractalsFirstEntrySignal firstEntrySignal, bool implementNCTZ, int initialStopTicks, NTFractalsLetterDisplayOptions letterDisplayOptions, NTFractalsLineDisplayOptions lineDisplayOptions, NTMACloudMAType mAType1, NTMACloudMAType mAType2, bool nTDeltaCrossEntryFilter, bool nTDeltaCrossTrailingStopFilter, NTFractalsDeltaCrossOptions nTFractalsDeltaCrossEntryOption, NTFractalsDeltaCrossOptions nTFractalsDeltaCrossTrailingStopOption, NTFractalsUltimateCandleOptions nTFractalsUltimateCandleEntryOption, NTFractalsUltimateCandleOptions nTFractalsUltimateCandleTrailingStopOption, bool nTMACloudEntryFilter, bool nTUltimateCandleEntryFilter, int nTUltimateCandleFilterNTMACloudReqEMAPeriod, bool nTUltimateCandleNTDeltaCrossTrailingStopCombo, bool nTUltimateCandleTrailingStopFilter, bool nTUltimateCandleTrailingStopMACloudReq, NTFractalsNumberOfEntrySignals numberOfEntrySignals, bool overrideEntryPlotColor, int period1, int period2, bool showReversalEntries, Font textFont, bool trailingStopEntry, bool trailingStopNLNH, bool trailingStopPBS, int trailingStopTicks)
        {
            return _indicator.NTFractals(input, alternativeEntryEMAPeriod, autoStopNLNH, autoStopNLNHTicks, firstEntrySignal, implementNCTZ, initialStopTicks, letterDisplayOptions, lineDisplayOptions, mAType1, mAType2, nTDeltaCrossEntryFilter, nTDeltaCrossTrailingStopFilter, nTFractalsDeltaCrossEntryOption, nTFractalsDeltaCrossTrailingStopOption, nTFractalsUltimateCandleEntryOption, nTFractalsUltimateCandleTrailingStopOption, nTMACloudEntryFilter, nTUltimateCandleEntryFilter, nTUltimateCandleFilterNTMACloudReqEMAPeriod, nTUltimateCandleNTDeltaCrossTrailingStopCombo, nTUltimateCandleTrailingStopFilter, nTUltimateCandleTrailingStopMACloudReq, numberOfEntrySignals, overrideEntryPlotColor, period1, period2, showReversalEntries, textFont, trailingStopEntry, trailingStopNLNH, trailingStopPBS, trailingStopTicks);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTMACloud NTMACloud(int cloudOpacity, Color downCloudColor, NTMACloudMAType mAType1, NTMACloudMAType mAType2, int period1, int period2, Color upCloudColor)
        {
            return _indicator.NTMACloud(Input, cloudOpacity, downCloudColor, mAType1, mAType2, period1, period2, upCloudColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTMACloud NTMACloud(Data.IDataSeries input, int cloudOpacity, Color downCloudColor, NTMACloudMAType mAType1, NTMACloudMAType mAType2, int period1, int period2, Color upCloudColor)
        {
            return _indicator.NTMACloud(input, cloudOpacity, downCloudColor, mAType1, mAType2, period1, period2, upCloudColor);
        }

        /// <summary>
        /// NewbieTrader.com - Color the background of a chart during specified input times
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTTimeBlock NTTimeBlock(int end, int start, Color timeSpanColor1)
        {
            return _indicator.NTTimeBlock(Input, end, start, timeSpanColor1);
        }

        /// <summary>
        /// NewbieTrader.com - Color the background of a chart during specified input times
        /// </summary>
        /// <returns></returns>
        public Indicator.NTTimeBlock NTTimeBlock(Data.IDataSeries input, int end, int start, Color timeSpanColor1)
        {
            return _indicator.NTTimeBlock(input, end, start, timeSpanColor1);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandle6E NTUltimateCandle6E(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandle6E(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandle6E NTUltimateCandle6E(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandle6E(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleCL NTUltimateCandleCL(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleCL(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleCL NTUltimateCandleCL(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleCL(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleES NTUltimateCandleES(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleES(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleES NTUltimateCandleES(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleES(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleGC NTUltimateCandleGC(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleGC(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleGC NTUltimateCandleGC(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleGC(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleHelper NTUltimateCandleHelper()
        {
            return _indicator.NTUltimateCandleHelper(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleHelper NTUltimateCandleHelper(Data.IDataSeries input)
        {
            return _indicator.NTUltimateCandleHelper(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleHelperES NTUltimateCandleHelperES()
        {
            return _indicator.NTUltimateCandleHelperES(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleHelperES NTUltimateCandleHelperES(Data.IDataSeries input)
        {
            return _indicator.NTUltimateCandleHelperES(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleHG NTUltimateCandleHG(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleHG(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleHG NTUltimateCandleHG(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleHG(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleNG NTUltimateCandleNG(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleNG(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleNG NTUltimateCandleNG(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleNG(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleNQ NTUltimateCandleNQ(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleNQ(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleNQ NTUltimateCandleNQ(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleNQ(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleTF NTUltimateCandleTF(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleTF(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleTF NTUltimateCandleTF(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleTF(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleYM NTUltimateCandleYM(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleYM(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleYM NTUltimateCandleYM(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleYM(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleZ NTUltimateCandleZ(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleZ(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleZ NTUltimateCandleZ(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleZ(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleZC NTUltimateCandleZC(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleZC(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleZC NTUltimateCandleZC(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleZC(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleZS NTUltimateCandleZS(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleZS(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleZS NTUltimateCandleZS(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleZS(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        ///  The squeeze indicator shows when the Bollinger Bands are contracting stronger than a Keltner Channel.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.anaSqueeze anaSqueeze(double numMultiplier, double numStdDev, int period)
        {
            return _indicator.anaSqueeze(Input, numMultiplier, numStdDev, period);
        }

        /// <summary>
        ///  The squeeze indicator shows when the Bollinger Bands are contracting stronger than a Keltner Channel.
        /// </summary>
        /// <returns></returns>
        public Indicator.anaSqueeze anaSqueeze(Data.IDataSeries input, double numMultiplier, double numStdDev, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.anaSqueeze(input, numMultiplier, numStdDev, period);
        }

        /// <summary>
        ///  The squeeze indicator shows when the Bollinger Bands are contracting stronger than a Keltner Channel.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTChops NTChops(double numMultiplier, double numStdDev, int period)
        {
            return _indicator.NTChops(Input, numMultiplier, numStdDev, period);
        }

        /// <summary>
        ///  The squeeze indicator shows when the Bollinger Bands are contracting stronger than a Keltner Channel.
        /// </summary>
        /// <returns></returns>
        public Indicator.NTChops NTChops(Data.IDataSeries input, double numMultiplier, double numStdDev, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTChops(input, numMultiplier, numStdDev, period);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCross6E NTDeltaCross6E()
        {
            return _indicator.NTDeltaCross6E(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCross6E NTDeltaCross6E(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCross6E(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossADD NTDeltaCrossADD()
        {
            return _indicator.NTDeltaCrossADD(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossADD NTDeltaCrossADD(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCrossADD(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossCL NTDeltaCrossCL()
        {
            return _indicator.NTDeltaCrossCL(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossCL NTDeltaCrossCL(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCrossCL(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossES NTDeltaCrossES()
        {
            return _indicator.NTDeltaCrossES(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossES NTDeltaCrossES(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCrossES(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossGC NTDeltaCrossGC()
        {
            return _indicator.NTDeltaCrossGC(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossGC NTDeltaCrossGC(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCrossGC(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossHG NTDeltaCrossHG()
        {
            return _indicator.NTDeltaCrossHG(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossHG NTDeltaCrossHG(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCrossHG(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossNG NTDeltaCrossNG()
        {
            return _indicator.NTDeltaCrossNG(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossNG NTDeltaCrossNG(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCrossNG(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossNQ NTDeltaCrossNQ()
        {
            return _indicator.NTDeltaCrossNQ(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossNQ NTDeltaCrossNQ(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCrossNQ(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossTF NTDeltaCrossTF()
        {
            return _indicator.NTDeltaCrossTF(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossTF NTDeltaCrossTF(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCrossTF(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossYM NTDeltaCrossYM()
        {
            return _indicator.NTDeltaCrossYM(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossYM NTDeltaCrossYM(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCrossYM(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossZ NTDeltaCrossZ()
        {
            return _indicator.NTDeltaCrossZ(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossZ NTDeltaCrossZ(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCrossZ(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossZC NTDeltaCrossZC()
        {
            return _indicator.NTDeltaCrossZC(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossZC NTDeltaCrossZC(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCrossZC(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTDeltaCrossZS NTDeltaCrossZS()
        {
            return _indicator.NTDeltaCrossZS(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTDeltaCrossZS NTDeltaCrossZS(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTDeltaCrossZS(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTFractals NTFractals(int alternativeEntryEMAPeriod, bool autoStopNLNH, int autoStopNLNHTicks, NTFractalsFirstEntrySignal firstEntrySignal, bool implementNCTZ, int initialStopTicks, NTFractalsLetterDisplayOptions letterDisplayOptions, NTFractalsLineDisplayOptions lineDisplayOptions, NTMACloudMAType mAType1, NTMACloudMAType mAType2, bool nTDeltaCrossEntryFilter, bool nTDeltaCrossTrailingStopFilter, NTFractalsDeltaCrossOptions nTFractalsDeltaCrossEntryOption, NTFractalsDeltaCrossOptions nTFractalsDeltaCrossTrailingStopOption, NTFractalsUltimateCandleOptions nTFractalsUltimateCandleEntryOption, NTFractalsUltimateCandleOptions nTFractalsUltimateCandleTrailingStopOption, bool nTMACloudEntryFilter, bool nTUltimateCandleEntryFilter, int nTUltimateCandleFilterNTMACloudReqEMAPeriod, bool nTUltimateCandleNTDeltaCrossTrailingStopCombo, bool nTUltimateCandleTrailingStopFilter, bool nTUltimateCandleTrailingStopMACloudReq, NTFractalsNumberOfEntrySignals numberOfEntrySignals, bool overrideEntryPlotColor, int period1, int period2, bool showReversalEntries, Font textFont, bool trailingStopEntry, bool trailingStopNLNH, bool trailingStopPBS, int trailingStopTicks)
        {
            return _indicator.NTFractals(Input, alternativeEntryEMAPeriod, autoStopNLNH, autoStopNLNHTicks, firstEntrySignal, implementNCTZ, initialStopTicks, letterDisplayOptions, lineDisplayOptions, mAType1, mAType2, nTDeltaCrossEntryFilter, nTDeltaCrossTrailingStopFilter, nTFractalsDeltaCrossEntryOption, nTFractalsDeltaCrossTrailingStopOption, nTFractalsUltimateCandleEntryOption, nTFractalsUltimateCandleTrailingStopOption, nTMACloudEntryFilter, nTUltimateCandleEntryFilter, nTUltimateCandleFilterNTMACloudReqEMAPeriod, nTUltimateCandleNTDeltaCrossTrailingStopCombo, nTUltimateCandleTrailingStopFilter, nTUltimateCandleTrailingStopMACloudReq, numberOfEntrySignals, overrideEntryPlotColor, period1, period2, showReversalEntries, textFont, trailingStopEntry, trailingStopNLNH, trailingStopPBS, trailingStopTicks);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTFractals NTFractals(Data.IDataSeries input, int alternativeEntryEMAPeriod, bool autoStopNLNH, int autoStopNLNHTicks, NTFractalsFirstEntrySignal firstEntrySignal, bool implementNCTZ, int initialStopTicks, NTFractalsLetterDisplayOptions letterDisplayOptions, NTFractalsLineDisplayOptions lineDisplayOptions, NTMACloudMAType mAType1, NTMACloudMAType mAType2, bool nTDeltaCrossEntryFilter, bool nTDeltaCrossTrailingStopFilter, NTFractalsDeltaCrossOptions nTFractalsDeltaCrossEntryOption, NTFractalsDeltaCrossOptions nTFractalsDeltaCrossTrailingStopOption, NTFractalsUltimateCandleOptions nTFractalsUltimateCandleEntryOption, NTFractalsUltimateCandleOptions nTFractalsUltimateCandleTrailingStopOption, bool nTMACloudEntryFilter, bool nTUltimateCandleEntryFilter, int nTUltimateCandleFilterNTMACloudReqEMAPeriod, bool nTUltimateCandleNTDeltaCrossTrailingStopCombo, bool nTUltimateCandleTrailingStopFilter, bool nTUltimateCandleTrailingStopMACloudReq, NTFractalsNumberOfEntrySignals numberOfEntrySignals, bool overrideEntryPlotColor, int period1, int period2, bool showReversalEntries, Font textFont, bool trailingStopEntry, bool trailingStopNLNH, bool trailingStopPBS, int trailingStopTicks)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTFractals(input, alternativeEntryEMAPeriod, autoStopNLNH, autoStopNLNHTicks, firstEntrySignal, implementNCTZ, initialStopTicks, letterDisplayOptions, lineDisplayOptions, mAType1, mAType2, nTDeltaCrossEntryFilter, nTDeltaCrossTrailingStopFilter, nTFractalsDeltaCrossEntryOption, nTFractalsDeltaCrossTrailingStopOption, nTFractalsUltimateCandleEntryOption, nTFractalsUltimateCandleTrailingStopOption, nTMACloudEntryFilter, nTUltimateCandleEntryFilter, nTUltimateCandleFilterNTMACloudReqEMAPeriod, nTUltimateCandleNTDeltaCrossTrailingStopCombo, nTUltimateCandleTrailingStopFilter, nTUltimateCandleTrailingStopMACloudReq, numberOfEntrySignals, overrideEntryPlotColor, period1, period2, showReversalEntries, textFont, trailingStopEntry, trailingStopNLNH, trailingStopPBS, trailingStopTicks);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTMACloud NTMACloud(int cloudOpacity, Color downCloudColor, NTMACloudMAType mAType1, NTMACloudMAType mAType2, int period1, int period2, Color upCloudColor)
        {
            return _indicator.NTMACloud(Input, cloudOpacity, downCloudColor, mAType1, mAType2, period1, period2, upCloudColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTMACloud NTMACloud(Data.IDataSeries input, int cloudOpacity, Color downCloudColor, NTMACloudMAType mAType1, NTMACloudMAType mAType2, int period1, int period2, Color upCloudColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTMACloud(input, cloudOpacity, downCloudColor, mAType1, mAType2, period1, period2, upCloudColor);
        }

        /// <summary>
        /// NewbieTrader.com - Color the background of a chart during specified input times
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTTimeBlock NTTimeBlock(int end, int start, Color timeSpanColor1)
        {
            return _indicator.NTTimeBlock(Input, end, start, timeSpanColor1);
        }

        /// <summary>
        /// NewbieTrader.com - Color the background of a chart during specified input times
        /// </summary>
        /// <returns></returns>
        public Indicator.NTTimeBlock NTTimeBlock(Data.IDataSeries input, int end, int start, Color timeSpanColor1)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTTimeBlock(input, end, start, timeSpanColor1);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandle6E NTUltimateCandle6E(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandle6E(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandle6E NTUltimateCandle6E(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandle6E(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleCL NTUltimateCandleCL(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleCL(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleCL NTUltimateCandleCL(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleCL(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleES NTUltimateCandleES(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleES(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleES NTUltimateCandleES(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleES(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleGC NTUltimateCandleGC(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleGC(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleGC NTUltimateCandleGC(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleGC(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleHelper NTUltimateCandleHelper()
        {
            return _indicator.NTUltimateCandleHelper(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleHelper NTUltimateCandleHelper(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleHelper(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleHelperES NTUltimateCandleHelperES()
        {
            return _indicator.NTUltimateCandleHelperES(Input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleHelperES NTUltimateCandleHelperES(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleHelperES(input);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleHG NTUltimateCandleHG(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleHG(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleHG NTUltimateCandleHG(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleHG(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleNG NTUltimateCandleNG(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleNG(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleNG NTUltimateCandleNG(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleNG(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleNQ NTUltimateCandleNQ(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleNQ(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleNQ NTUltimateCandleNQ(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleNQ(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleTF NTUltimateCandleTF(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleTF(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleTF NTUltimateCandleTF(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleTF(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleYM NTUltimateCandleYM(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleYM(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleYM NTUltimateCandleYM(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleYM(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleZ NTUltimateCandleZ(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleZ(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleZ NTUltimateCandleZ(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleZ(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleZC NTUltimateCandleZC(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleZC(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleZC NTUltimateCandleZC(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleZC(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.NTUltimateCandleZS NTUltimateCandleZS(Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            return _indicator.NTUltimateCandleZS(Input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.NTUltimateCandleZS NTUltimateCandleZS(Data.IDataSeries input, Color bearish3Color, Color bearish4Color, Color bullish3Color, Color bullish4Color, Color neutralColor)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.NTUltimateCandleZS(input, bearish3Color, bearish4Color, bullish3Color, bullish4Color, neutralColor);
        }
    }
}
#endregion
